;****************************************************************************
; NEWGAME : Etablit une nouvelle partie.
; Entres : Aucune
; Sorties : Aucune
; Modif   : Rien
newgame:
        pushall                 ; Sauve tout
        lea niveaux(PC),A0      ; Source compressee
        lea niv(PC),A1          ; Destination niveau
        clr.l D3                ; Efface
        move.b niv_cur,D3       ; File N de niveau
        jsr hufflib[extract]    ; Extrait tout
        lea fin_niv(PC),A0      ; Prend source
        lea pl_cur(PC),A1       ; Prend cible
        add.l #1,A0             ; Deplace d'un
        move.b (A0)+,(A1)+      ; Copie joueur courant
        lea players(PC),A1      ; Charge les joueurs
        move.w (A0)+,(A1)+      ; Copie pos joueur 1
        add.l #2,A1             ; Additionne 2 a dest
        move.w (A0)+,(A1)+      ; Copie pos joueur 2
        add.l #2,A1             ; Additionne 2 a dest
        move.w (A0)+,(A1)+      ; Copie pos joueur 3
        add.l #2,A1             ; Additionne 2 a dest
        move.w (A0)+,(A1)+      ; Copie pos joueur 4
        popall                  ; Recupere tout
        bsr afffirst            ; Affiche au depart
        bsr affall              ; Afffiche tout
        rts                     ; Retour a l'applelant

;****************************************************************************
; AFFFIRST : Affiche l'ecran de depart en effacant le superflu.
; Entres : Rien
; Sorties : Rien
; Modif   : Rien
afffirst:
        pushall                 ; Sauve tout
        jsr flib[clr_scr]       ; Efface plan 1
        move.w #2,-(A7)         ; Choisi gosse fonte
        jsr romlib[set_font]    ; Choisi fonte
        lea 2(A7),A7            ; Restaure pile
        move.w #4,-(A7)         ; Couleur noir sur blanc
        pea mesniv(PC)          ; Niveau
        move.w #4,-(A7)         ; Y=4
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea fin_niv(PC)         ; Numero Niveau
        add.l #10,(A7)          ; Corrige decalage
        move.w #4,-(A7)         ; Y=4
        move.w #222,-(A7)       ; X=222
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        move.l #4,D0            ; 5 lettres
        lea meskw(PC),A1        ; met adresse lettres
        move.w #30,D1           ; Ydep = 30
kwlte:  push D0                 ; Sauve D0
        push D1                 ; Sauve D1
        push A1                 ; Sauve A1
        move.l A1,-(A7)         ; met adresse lettre
        move.w D1,-(A7)         ; met Y
        move.w #15,-(A7)        ; X = 20
        jsr romlib[puttext]     ; Affiche lettre
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pop A1                  ; Recupere A1
        pop D1                  ; Recupere D1
        pop D0                  ; Recupere D0
        add.l #2,A1             ; Ajoute 2 au decalage
        add.w #15,D1            ; Ajoute 15 a la ligne
        dbra D0,kwlte           ; boucle
        lea 2(A7),A7            ; Recupere toute la pile
        move.w #0,-(A7)         ; Choisi petite fonte
        jsr romlib[set_font]    ; Choisi fonte
        lea 2(A7),A7            ; Restaure pile
        move.w #4,-(A7)         ; Couleur noir sur blanc
        pea h0(PC)              ; Aide 0
        move.w #77,-(A7)        ; Y=77
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h1(PC)              ; Aide 1
        move.w #85,-(A7)        ; Y=85
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h2(PC)              ; Aide 2
        move.w #91,-(A7)        ; Y=91
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h3(PC)              ; Aide 3
        move.w #97,-(A7)        ; Y=97
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h4(PC)              ; Aide 4
        move.w #103,-(A7)       ; Y=103
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h5(PC)              ; Aide 5
        move.w #109,-(A7)       ; Y=109
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 8(A7),A7            ; Recupere pile sauf couleur
        pea h6(PC)              ; Aide 6
        move.w #115,-(A7)       ; Y=115
        move.w #202,-(A7)       ; X=202
        jsr romlib[puttext]     ; Affiche
        lea 10(A7),A7           ; Recupere pile et couleur
        move.w #0,-(A7)         ; Couleur blanc sur noir 
        pea h7(PC)              ; Aide 7
        move.w #121,-(A7)       ; Y=121
        move.w #0,-(A7)         ; X=0
        jsr romlib[puttext]     ; Affiche
        lea 10(A7),A7           ; Recupere pile et couleur
        jsr eff_gray            ; Efface plan 0 en laissant le double noir
        popall                  ; Recupere tout
        rts                     ; Retour a l'appelant


;****************************************************************************
; TSTROT  : Teste la rotation du pivot pour un coin donne.
; Entres : A1.l : Pointeur sur le pivot
;           D4.l : Sens de rotation
;           D2.l : Incrementation
;           D5.l : Incremetation relle en cours de traitement
;           D6.b : Bit a tester
; Sorties : D3 mis a -1 si pb
; Modif   : ????
tstrot:
        push D0                 ; Sauve D0
        push D5                 ; Sauve D5
        move.b (A1),D0          ; Recupere le pivot
        btst.b D6,D0            ; Test le caract haut ?
        bne trfok               ; Pas de haut on saute
        muls D4,D2              ; On retablit le sens
        ext.l D2                ; On etends le signe.
        move.l A1,A2            ; A1->A2
        add.l D2,A2             ; Pointe sur dest
        push D6                 ; Sauve D6
        add.l D4,D6             ; Nouveau bit
        cmp.b #8,D6             ; Test de depassement haut
        bne trde1               ; Si non on saute
        move.l #4,D6            ; Si depassement on rectifie
trde1:  cmp.b #3,D6             ; Test de depassement bas
        bne trde2               ; Si non on saute
        move.l #7,D6            ; Si depassement on rectifie
trde2:  btst.b D6,D0            ; Test l'autre ?
        beq trhok               ; Du haut on saute
        move.b (A2),D5          ; Recupere destination
        and.b #$0F,D5           ; Garde le type
        cmp.b #0,D5             ; Vide ?
        beq trhok               ; Si oui ok
        cmp.b #3,D5             ; Trou ?
        beq trhok               ; Si oui ok
        move.l #-1,D3           ; Pb on met a -1
trhok:  pop D6                  ; Recupere D6  <- Retour imperatif !!
        pop D5                  ; Recupere D5
        add.l D5,A2             ; Pointe sur le coin
        push D5                 ; Sauve D5 
        move.b (A2),D5          ; Prend la case dans D5
        and.b #$0F,D5           ; Ne garde que le type
        cmp.b #00,D5            ; Vide ?
        beq trfok               ; Si oui ok
        cmp.b #03,D5            ; Trou ?
        beq trfok               ; Si oui ok
        move.b pl_cur,D0        ; Joueur en cours
        add.b #4,D0             ; Numero de caractere
        cmp.b D0,D5             ; Joueur en cours ?
        beq trfok               ; Si oui ok
        move.l #-1,D3           ; Sinon PAS BON
trfok:  pop D5                  ; Recupere D5
        pop D0                  ; Recupere D0
        rts                     ; Retour a l'appelant

;****************************************************************************
; ROTATE  : Fait tourner le pivot pour un coin donne.
; Entres : A1.l : Pointeur sur le pivot
;           D4.l : Sens de rotation
;           D2.l : Incrementation
;           D5.l : Attributs (En haut si trig, en bas si horaire)
;           D6.b : Bit a tester
; Sorties : Aucune
; Modif   : ????
rotate:
        push D3                 ; Sauve D3
        push D6                 ; Sauve D6
        add.b D4,D6             ; Change la case a tester
        cmp.b #8,D6             ; Test de depassement haut
        bne rrde1               ; Si non on saute
        move.l #4,D6            ; Si depassement on rectifie
rrde1:  cmp.b #3,D6             ; Test de depassement bas
        bne rrde2               ; Si non on saute
        move.l #7,D6            ; Si depassement on rectifie
rrde2:  btst.b D6,D0            ; Test le caract
        beq rrs1                ; Si qq chose on continue
        pop D6                  ; Recupere D6
        btst.b D6,D0            ; Est-ce qq chose dans case tst
        bne rhs2                ; Si rien on quitte
        bra rrs2                ; On saute le pop
rrs1:   pop D6                  ; Recupere D6
rrs2:   muls D4,D2              ; On retablit le sens
        ext.l D2                ; On etends le signe.
        move.l A1,A2            ; A1->A2
        add.l D2,A2             ; Pointe sur dest
        and.b #$0F,(A2)         ; Supprime les attributs
        move.b (A2),D3          ; Garde en mem le type
        push D5                 ; Sauvegarde D5
        btst.b D6,D0            ; Test le caract haut ?
        bne rvid                ; Pas de haut on saute
        cmp.b #1,D4             ; Test sens
        bne rhho                ; Si pas trigo -> RotationHautHOraire
        swap D5                 ; Garde les attributs trigo
        move.b D5,(A2)          ; Met les Attributs
        bra rfat                ; On saute
rhho:   move.b D5,(A2)          ; Met les attributs
rfat:   move.l #$000B000C,D5    ; On met le plein
        bra rs1                 ; On saute
rvid:   move.b #0,(A2)          ; On efface la case
        move.l #$00000003,D5    ; On met du vide
rs1:    cmp.b #3,D3             ; Est-ce trou ?
        beq rhtr                ; Si oui on y va
        cmp.b #12,D3            ; Est-ce ext pivot sur trou ?
        beq rhtr                ; Si oui on y va
        swap D5                 ; On inverse D5 pour le sol
        or.b D5,(A2)            ; Sinon exterieur sur sol
        bra rhs1                ; On passe
rhtr:   or.b D5,(A2)            ; Sinon exterieur sur trou
rhs1:   pop D5                  ; Recupere D5
rhs2:   pop D3                  ; Recupere D0
        rts                     ; Retour a l'appelant

;****************************************************************************
; REPPIVOT: Repere le pivot du tourniquet.
; Entres : D1.w : Direction
; Sorties : A1   : Pointe sur le pivot
;           D4   : Sens de rotation : -1 horaire, 1 trigo
; Modif   : ????
reppivot:
        move.b 0(A0,D1),D5      ; Charactere dans case objectif
        and.b #$F0,D5           ; Ne garde que les liens
        btst #7,D5              ; Gauche ?
        bne btga                ; Si non on passe
        move.l #-1,D4           ; Si oui on repere le pivot
btga:   btst #6,D5              ; Haut ?
        bne btha                ; Si non on passe
        move.l #-20,D4          ; Si oui on repere le pivot
btha:   btst #5,D5              ; Droite ?
        bne btdr                ; Si non on passe
        move.l #1,D4            ; Si oui on repere le pivot
btdr:   btst #4,D5              ; Bas ?
        bne btba                ; Si non on passe
        move.l #20,D4           ; Si oui on repere le pivot
btba:   move.l A0,A1            ; A0->A1
        add.l D1,A1             ; Pointe sur la case destination
        add.l D4,A1             ; A1 pointe sur le pivot
        muls.w D1,D4            ; on multiplie par D4 (calcul du sens)
        cmp.w #0,D4             ; superieur  0 ?
        bgt trig                ; Si oui : sens trigo
        move.l #-1,D4           ; On met -1 dans D4 (sens)
        bra trs1                ; suite
trig:   move.l #1,D4            ; on met 1 dans le sens D4
trs1:   cmp.b #-20,D1           ; vert ?
        beq tsf                 ; oui on passe
        cmp.b #20,D1            ; vert ?
        beq tsf                 ; oui on passe
        neg.l D4                ; sinon on echange
tsf:    rts                     ; Retour a l'appelant

;****************************************************************************
; DEPLIGNE: Deplace la ligne de blocs pointee par A1.
; Entres : D1.w : Direction
;           D2.w : =1 si tous sur un trou
;           A1.l : Pointe sur la ligne
;           D6.w : Masque d'arret
; Sorties : D2 = 1 si tout est dans un trou
; Modif   : Rien
depligne:
        push A1                 ; Sauve A1
        push D7                 ; Sauve D7
        move.l D2,D7            ; Transfert D2 -> D7
        push D0                 ; Sauve D0
        push D2                 ; Sauve D2
        push A1                 ; Sauve A1
        move.b (A1),D0          ; Lit le caractere premier
        and.b D6,D0             ; Teste la fin
        cmp.b #0,D0             ; Est-ce la fin
        bne dlbf2               ; Si oui fin boucle
        add.l D1,A1             ; Caractere suivant
dlbcl:  move.b (A1),D0          ; Lit le caractere suivant
        push D0                 ; Sauve D0
        and.b #$0F,D0           ; Garde le type
        cmp.b #09,D0            ; Sur trou ?
        beq dls0                ; Si oui ok
        move.l #0,D7            ; Un bloc n'est pas sur un trou
dls0:   pop D0                  ; Restaure D0
        and.b D6,D0             ; Teste la fin
        cmp.b #0,D0             ; Est-ce la fin
        bne dlbf1               ; Si oui fin boucle
        add.l D1,A1             ; Caractere suivant
        bra dlbcl               ; non on continue
dlbf1:  push D6                 ; Sauve D6
        not D6                  ; Non D6
        and.b D6,(A1)           ; Elimine le caractere de gauche
        pop D6                  ; Restaure D6
dlbf2:  move.b (A1),D0          ; Lit le dernier caractere
        and.b #$F0,D0           ; Lit les attributs
        cmp.b #0,0(A1,D1)       ; case suivante vide ?
        bne gota                ; si non on va a la suite
        or.b #$08,D0            ; bloc sur sol
        move.l #0,D7            ; les blocs ne sont pas tous sur des trous
        bra gos5                ; suite
gota:   or.b #$09,D0            ; sinon bloc sur trou
gos5:   or.b D6,D0              ; Met le bit efface
        move.b D0,0(A1,D1)      ; on sauve dans la carte
deb:    pop A1    
        move.b (A1),D0          ; Caractere courant
        push D0                 ; Sauve D0
        and.b #$F0,D0           ; Garde les attributs
        and.b #$0F,0(A1,D1)     ; Efface les attributs precedents
        or.b D0,0(A1,D1)        ; Met les attributs courants
        pop D0                  ; Recupere D0
        and.b #$0F,D0           ; Garde le type
        cmp.b #8,D0             ; bloc sur sol
        bne btr                 ; sinon trou
        move.b #0,(A1)          ; on efface la case
        bra dlfin               ; on va faire la boucle
btr:    move.b #3,(A1)          ; on laisse le trou
dlfin:  pop D2                  ; Recupere D2
        pop D0                  ; Recupere D0
        move.l D7,D2            ; Renvoie le resultat
        pop D7                  ; Recupere D7
        pop A1                  ; Recupere A1
        rts                     ; Retour a l'appelant

;****************************************************************************
; DEPTEST : Deplace le pointeur A1 jusqu'a l'extremite du bloc.
; Entres : D1.w : Direction
;           A1.l : Pointe sur la ligne
;           D6.w : Masque d'arret
; Sorties : Aucune
; Modif   : A1 : pointe sur le caract.
deptest:
        push D0                 ; Sauve D0
dtbcl:  move.b (A1),D0          ; Lit le caractere suivant
        and.b D6,D0             ; Teste la fin
        add.l D1,A1             ; Caractere suivant
        cmp.b #0,D0             ; Est-ce la fin
        beq dtbcl               ; Si non on boucle
        pop D0                  ; Recupere D0
        rts                     ; Retour a l'appelant

;****************************************************************************
; EFFLINE : Efface la ligne du bloc.
; Entres : D1.w : Direction
;           A1.l : Pointe sur la ligne
;           D6.w : Masque d'arret
; Sorties : Aucune
; Modif   : Rien
effline:
        push D0                 ; Sauve D0
        push A1                 ; Sauve A1
elbcl:  move.b (A1),D0          ; Lit le caractere suivant
        move.b #0,(A1)          ; Efface
        and.b D6,D0             ; Teste la fin
        add.l D1,A1             ; Caractere suivant
        cmp.b #0,D0             ; Est-ce la fin
        beq elbcl               ; Si non on boucle
        pop A1                  ; Recupere A1
        pop D0                  ; Recupere D0
        rts                     ; Retour a l'appelant

;****************************************************************************
; GETORTHO: Renvoie les direction orthogonales.
; Entres : D1.w : Direction
; Sorties : D4,D5: Directions orthogonales a D1 avec masque
;           D6   : Masque d'arret lateral
; Modif   : D4,D5,D6 (!)
getortho:
        cmp.b #-1,D1                    ; Decalage vers la gauche ?
        bne gos1                        ; Si non suivant
        move.l #%10000000,D6            ; Masque gauche
        bra gohor                       ; Horizontal
gos1:   cmp.b #1,D1                     ; Decalage vers la droite ?
        bne gover1                      ; Si non vertical
        move.l #%00100000,D6            ; Masque droit
gohor:  move.w #%01000000,D4            ; Masque haut
        move.w #%00010000,D5            ; Masque bas
        swap D4                         ; On permute
        swap D5                         ; On permute
        move.w #-20,D4                  ; Direction haut
        move.w #20,D5                   ; Direction bas
        bra gofin                       ; Fin
gover1: cmp.b #-20,D1                   ; Haut ?
        bne gobas                       ; Sinon bas
        move.l #%01000000,D6            ; Masque haut
        bra govert
gobas:  move.l #%00010000,D6            ; Masque bas
govert: move.w #%10000000,D4            ; Masque gauche
        move.w #%00100000,D5            ; Masque droit
        swap D4                         ; On permute
        swap D5                         ; On permute
        move.w #-1,D4                   ; Direction gauche
        move.w #1,D5                    ; Direction droite
gofin:  rts                             ; Retour a l'appelant

;****************************************************************************
; AFFALL  : Afffichage de l'cran de jeu.
; Entres : Rien
; Sorties : Rien
; Modif   : Rien
affall: push D0                 ; Sauve les registres
        push D1
        push D2
        push D3
        push A0
        push A1
        lea des(PC),A0          ; Charge les dessins dans A0
        lea fin_niv(PC),A1      ; Charge le niveau dans A1
        move.w #dim_y,D1        ; Dimension Y dans D1
yloop:  move.w #dim_x,D0        ; Dimension X dans D0
xloop:  clr.l D2                ; On efface D2
        move.b -(A1),D2         ; On charge la case en cours dans D2
        move.l D2,D3            ; On copie dans D3
        and.b #$0F,D3           ; Garde le contenu de la case
        push A0                 ; Sauve A0
        mulu.w #des_size,D3     ; Calcule le dcalage
        add.l D3,A0             ; et l'ajoute a A0
        and.b #$F0,D2           ; Garde les attributs
        jsr affbloc             ; Affiche le bloc
        pop A0                  ; Rcupere A0
        dbra D0,xloop           ; Boucle X
        dbra D1,yloop           ; Boucle Y
        pop A1                  ; Rcupere les registres
        pop A0
        pop D3
        pop D2
        pop D1
        pop D0
        rts

;****************************************************************************
; AFFPLAYER : Affiche le joueur courant.
; Entres : Rien
; Sorties : Rien
; Modif   : Rien
affplayer:        
        pushall                 ; On sauve tout
        move.b pl_cur,D3        ; On charge le numero du joueur
        move.l D3,D4            ; On met D3->D4
        add.l #4,D4             ; Numero de sprite
        mulu.w #14,D4           ; Pointe sur sprite
        lea des(PC),A0          ; Pointe sur les dessins
        add.l D4,A0             ; Pointe sur joueur
        clr.l D2                ; Efface les attributs
        move.l #22,D0           ; Position X
        move.l #8,D1            ; Position Y
        bsr affbloc             ; affiche
        popall                  ; Recupere tout
        rts 

;****************************************************************************
; AFFBLOC : Afffichage d'un bloc 8x7 en index 8x7 en ton de gris.
; Entres :     D0.w : position x indexe. 0..19
;               D1.w : position y indexe. 0..17
;               D2.b : 4 bits d'attributs.               
;               A0.l : pointeur sur l'image. (7 octets)
;             | A1.l : pointeur sur l'cran 1 (LCD = $4440) | Auto
;             | A6.l : pointeur sur l'ecran 2               | Auto
; Sorties : Rien
; Modif   : Rien
affbloc:
        push A0                 ; Sauve les registres
        push A1
        push A6
        push D0
        push D1
        push D2
        push D3
        add.w #5,D0             ; On dcale l'affichage de 5 pour centrer
        clr.l D3                ; Efface D3
        btst #7,D2              ; Test le lien gauche
        beq pg                  ; Si lien on saute
        or.b #%10000000,D3      ; met le mur gauche dans le masque D3
pg:     btst #5,D2              ; Test  droite
        beq pd                  ; Si lien on saute
        or.b #%00000001,D3      ; met le mur droit sur le masque D3
pd:     move.l #$4440,A1        ; charge l'ecran LCD b&w
        add.w D0,A1             ; decalage X plan 1
        add.w D0,A6             ; dcalage Y plan 0
        mulu.w #7,D1            ; calcule le decalage Y
        mulu.w #30,D1           ;    en index 7x8 30o/lignes 
        add.w D1,A1             ; decalage Y plan 1
        add.w D1,A6             ; decalage Y plan 0
        move.l #5,D0            ; on fait une boucle de 6
        move.b (A0)+,(A1)       ; on copie la premiere ligne plan 1
        or.b D3,(A1)            ; on applique le masque
        move.b (A0)+,(A6)       ; on copie la premiere ligne plan 0
        or.b D3,(A6)            ; on applique le masque
        btst #6,D2              ; lien en haut ?
        beq ph                  ; si oui on saute
        move.b #%11111111,(A1)  ; sinon on met une ligne plan 1
        move.b #%11111111,(A6)  ; sinon on met une ligne plan 0
ph:     add.l #30,A1            ; on va a la ligne suivante pl1
        add.l #30,A6            ; on va a la ligne suivante pl0
ab8bl:  move.b (A0)+,(A1)       ; on copie la ligne pl1
        or.b D3,(A1)            ; on applique le masque D3 pl1
        move.b (A0)+,(A6)       ; on copie la ligne pl0
        or.b D3,(A6)            ; on applique le masque D3 pl0
        add.l #30,A1            ; ligne suivante pl1
        add.l #30,A6            ; ligne suivante pl0
        sub.w #1,D0             ; on dcrmente le compteur D0
        cmp.w #0,D0             ; D0=0 ?
        bne ab8bl               ; si non on continue
        move.b (A0)+,(A1)       ; on copie la derniere ligne pl1
        or.b D3,(A1)            ; on applique le masque pl1
        move.b (A0)+,(A6)       ; on copie la derniere ligne pl0
        or.b D3,(A6)            ; on applique le masque pl0
        btst #4,D2              ; lien en bas ?
        beq pb                  ; si oui on saute
        move.b #%11111111,(A1)  ; sinon on met une ligne pl1
        move.b #%11111111,(A6)  ; sinon on met une ligne pl0
pb:     pop D3                  ; Rcupere les registres
        pop D2
        pop D1
        pop D0
        pop A6
        pop A1
        pop A0
        rts                     ; Retour  l'appelant

;****************************************************************************
; EFF_GRAY : Efface l'ecran grayscale  | Copie l'ecran b&w
; Entres :   | A6.l : pointeur sur l'ecran 2               | Auto
; Sorties : Rien
; Modif   : Rien
eff_gray:
        push A6                 ; Sauve les registres 
        push A5
        push D0
        push D1
        clr.l D1                ; Efface D1
        move.l #$3BE,D0         ; Initialise le compteur
        move.l #$4440,A5        ; Ecran graphique
effl:   move.l (A5)+,(A6)+      ; Copie (Mettre D1 si efface)
        dbra D0,effl            ; Boucle
        pop D1                  ; Rcupere les registres
        pop D0
        pop A5
        pop A6
        rts                     ; Retour  l'appelant

des:
vide    dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
mur     dc.b    %11111111,%11111111
        dc.b    %00100000,%11111111
        dc.b    %00100000,%11111111
        dc.b    %11111111,%11111111
        dc.b    %00000100,%11111111
        dc.b    %00000100,%11111111
        dc.b    %00000100,%11111111
sortie  dc.b    %11100000,%11100000
        dc.b    %10111000,%11111000
        dc.b    %10101110,%11111110
        dc.b    %10101010,%11111110
        dc.b    %11101010,%11111110
        dc.b    %11111010,%11111110
        dc.b    %11111110,%11111110
trou    dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
        dc.b    %11111111,%11111111
perso1  dc.b    %00000000,%00000000
        dc.b    %00111100,%00111100
        dc.b    %01000010,%01111110
        dc.b    %11111111,%11111111
        dc.b    %11000011,%11111111
        dc.b    %01011010,%01111110
        dc.b    %00111100,%00111100
perso2  dc.b    %00000000,%00000000
        dc.b    %10100101,%10100101
        dc.b    %11011011,%11111111
        dc.b    %10100101,%11111111
        dc.b    %10100101,%11111111
        dc.b    %10000001,%11111111
        dc.b    %01111110,%01111110
perso3  dc.b    %00000000,%00000000
        dc.b    %00000110,%00000110
        dc.b    %00011001,%00011111
        dc.b    %01100001,%01111111
        dc.b    %10100101,%11111111
        dc.b    %10000001,%11111111
        dc.b    %01111110,%01111110
perso4  dc.b    %00000000,%00000000
        dc.b    %00111100,%00111100
        dc.b    %11111111,%11111111
        dc.b    %10100101,%11111111
        dc.b    %10000001,%11111111
        dc.b    %01011010,%01111110
        dc.b    %00111100,%00111100
bloc1   dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
bloc2   dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
        dc.b    %11111111,%00000000
pivot   dc.b    %00111100,%00000000
        dc.b    %00100100,%00000000
        dc.b    %11011011,%00011000
        dc.b    %10100101,%00111100
        dc.b    %11011011,%00011000
        dc.b    %00100100,%00000000
        dc.b    %00111100,%00000000
exts    dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00111100,%00000000
        dc.b    %00111100,%00000000
        dc.b    %00111100,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
extt    dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00111100,%00000000
        dc.b    %00111100,%00000000   
        dc.b    %00111100,%00000000
        dc.b    %00000000,%00000000
        dc.b    %00000000,%00000000
niv     dc.b $C1,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$61
        dc.b $81,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$21
        dc.b $81,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$21
        dc.b $81,$01,$01,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$01,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$04,$00,$05,$00,$06,$00,$07,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C8,$68,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$98,$38,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$02,$00,$00,$00,$03,$03,$00,$00,$F8,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$00,$00,$00,$03,$03,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$EB,$00,$00,$03,$00,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$DB,$1A,$7C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$21,$00,$00,$03,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$81,$01,$01,$21
        dc.b $81,$01,$01,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$41,$01,$01,$01,$21
        dc.b $81,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$21
        dc.b $81,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$21
        dc.b $91,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$11,$31
fin_niv dc.b 4,0                ; Nombre de joueurs et dummy
        dc.w 104,106,108,110    ; Position des joueurs
        dc.b "00",0             ; Numero niveau


